// tree search    4 Oct 2011

#include <ailib.h>

#define eqs(str1,str2)    strcmp(str1,str2) == 0

int append(int ls1, int ls2){
	if( ls1 == NIL ) return ls2;
	else return cons(head(ls1), append(tail(ls1),ls2));
}

// association list = ( record record ...)
//    record = ( key attributes )

int chula;

int list2(char *str1, char *str2){
	return cons(name(str1),cons(name(str2),NIL));
}

int list3(char *str1, char *str2, char *str3){
	return cons(name(str1),cons(name(str2),cons(name(str3),NIL)));
}

int make_record(char *key, int att){
	return cons(name(key),list(att));
}

int make_chula(void){
	int a,b,c,d,e,f,g,h,i;
	a = list3("siam","rachaprasong","hualampong");
	b = make_record("chula",a);
	c = list3("mbk","paragon","natstadium");
	d = make_record("siam",c);
	e = list2("centralworld","pratunam");
	f = make_record("rachaprasong",e);
	g = list(name("yaowarad"));
	h = make_record("hualampong",g);
	return cons(b,cons(d,cons(f,cons(h,NIL))));
}

extern char *get_string(int a);

int atomeq(int x, int y){
	if( ! isatom(x) ) return 0;
	if( ! isatom(y) ) return 0;
	if( head(x) != head(y) ) return 0;
	if( head(x) == TYNUMBER ) return tail(x) == tail(y);
    return eqs(get_string(x),get_string(y));
}

void test_atomeq(void){
	int a, b, c, d;
	a = name("A");
	b = name("A");
	c = number(2);
	d = number(2);
//	printf("%s\n",get_string(a));
	printf("%d\n",atomeq(a,b));
	printf("%d\n",atomeq(c,d));
}

int search_asso(int key, int alist){
	if( alist == NIL ) return NIL;
	if( atomeq(key, head(head(alist)))) return head(tail(head(alist)));
	else return search_asso(key, tail(alist));
}

int expand(int node, int alist){
	return search_asso(node,alist);
}

int isgoal(int node){
	return atomeq(node,name("centralworld"));
}

int tree_search(int problem, int fringe){
	if( fringe == NIL ) return NIL;
	if( isgoal(head(fringe)) ) return head(fringe);
	else{
		fringe = append(tail(fringe),expand(head(fringe),problem));
		print_list(fringe); nl();
		return tree_search(problem,fringe);
	}
}

int main(void){
	int a;
//	a = list3("A","B","C");
//	print_list(a); nl();
	chula = make_chula();
	print_list(chula); nl();
//	test_atomeq();
//	a = search_asso(name("siam"),chula);
//	print_list(a); nl();
	a = tree_search(chula,list(name("chula")));
	print_list(a); nl();
}

